/* misc.h for rtc --- misc. functions

Copyright (c) 1993,1994 Richard M. Offer.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


Although the GPL allows you to modify the code to your hearts content,
could you be polite and send me a copy of any changes (but not patches, my
code may have changed). If you are considering adding additional
features, you might me better contacting me to make sure I'm not one
step ahead of you :-)

richard.

$Id: rtc-misc.h,v 1.2 1995/07/03 09:24:41 richardo Exp $

*/

#ifndef RTC_MISC_H
#define RTC_MISC_H

extern int RtcExtractString(
#if NeedFunctionPrototypes
			    char	**out,
			    char	*in,
			    char	*delim
#endif
			    );

extern char **RtcSplitString(
#if NeedFunctionPrototypes
			     char	*string,
			     char	sep,
			     int	*nstrings
#endif
			     );



extern void RtcParseOptionsList(
#if NeedFunctionPrototypes
				RTCObject	*object,
				char		*option_string
#endif
				);

extern char *RtcFindFileInPath(
#if NeedFunctionPrototypes
			       char	*path,
			       char	*filename
#endif
			       );


extern char *RtcExpandShellVariable(
#if NeedFunctionPrototypes
				    char	*input,
				    int	stop
#endif
			       );


extern void RtcMsg(
#if NeedVarargsPrototypes
		   RTCMaster	*master,
		   ErrorType	type,
		   char		*format,
		   ...
#endif
		   );


extern void RtcBeep(
#if NeedFunctionPrototypes
		    RTCMaster	*master,
		    int		volume,
		    int		duration
#endif
		    );

#endif
